/*
                        Inizializzazione MICRO
                        PIC12F18XX
                        PIC16F18XX

*/
// ***************************************************************************** Inizializzazione PIC
//
// *****************************************************************************
 void Init_PIC () {
//
// --- ANALOGICA
  ANSELA = 0b00000000;     // RA0 input analog
//  ANSELB = 0b00000000;     // Solo per PIC16F1829
  ANSELC = 0b00000010;     //
  ADCON0 = 0b00000000;     //
  ADCON1 = 0b10100000;     // Vdd, Vss, Fosc/32, Dx justified
  //CPSCON0.CPSON = 0;       // Disable modulo capacitivo
 // FVRCON = 0b11000001;     // Riferimento di tensione interno = 1024 mV per ADC
 // ADCON0 = 0b00001000;     // AN2
 // ADCON1 = 0b11100011;     // Riferimento = FVR (1024mV), FOSC/64, Dx  0b11100011;
// --- DAC
  DACCON0 = 0b11000000;
  DACCON1 = 0b00010000;    // 1/2 Vcc
// --- COMPARATORI
  CM1CON0 = 0b10110100;    // enable comparator 1
  CM1CON1 = 0b10010001;    // in+ = FVR, in- = in1- (RC1)
  C2ON_bit = 0;            // Disable Comp.2
// --- OSCILLATORE
 // OSCCON = 0b11110000;     // Oscillatore (8MHz) + PLL = 32MHz
  OSCCON = 0b11110000;     // Oscillatore 8MHz + PLL = 32MHz
// --- TMR6 (Sample long & tick)
//
  T6CON = 0b00000111;       // Post 1/1, TMR6 ON, pre 1/64
  PR6 = 125;               // Con osc=32MHz e PR6=125 => interrupt: 1ms
// --- INTERRUPT
// --- Interrupt Comparator C1
 // PIE2.C1IE = 1;
  PIR2.C1IF = 0;
// --- Interrupt TMR6
  PIE3.TMR6IE = 1;          // Abilita interrupt TMR6
  PIR3.TMR6IF = 0;
//  INTCON |= 0b11000000;     // Abilita interrupt
    INTCON &= 0b00111111;     // Disabilita interrupt
//  INTCON.TMR0IE =1;
// --- PWM
  CCP1CON = 0b00000000;     // 0b00001100
  CCP2CON = 0b00000000;
 // CCPTMRS0 = 0b11111100;
 // T2CON = 0b00000101;
 // PR2 = 83;
 // CCPR1L = 41;
// --- UART
//  APFCON0 = 0b10000100;     // RX = RA1, TX = RA0
// --- I/O
  PORTA = 0;
 // PORTB = 0;                // Solo per PIC16F1829
  PORTC = 0;
  TRISA = 0b11001010;       // presenti: --XXXXXX
//  TRISB = 0b11110000;       // presenti: XXXX----     Solo per PIC16F1829
  TRISC = 0b11000111;       // presenti: --XXXXXX
  WPUA = 0b00001110;        // PULL-UP
//  WPUB = 0b11110000;        // PULL-UP                Solo per PIC16F1829
  WPUC = 0b00000101;        // PULL-UP
  OPTION_REG.B7 =0;         // Weak pull-ups are enabled
 //
 }
/*
 Mappatura pins del PIC16F1825
// --- Pull-Up: tutti
 RA0 = pin 19   ICSP_DAT                Tx  AN0
 RA1 = pin 18   ICSP_CLK                Rx        AN1
 RA2 = pin 15                                                AN2
 RA3 = pin 4    MCLR
 RA4 = pin 3            OSC2                AN3
 RA5 = pin 2            OSC1
//
 RC0 = pin 10                                                AN4
 RC1 = pin 9                                                AN5
 RC2 = pin 8                                                  AN6
 RC3 = pin 7                                                  AN7
 RC4 = pin 6                                          Tx
 RC5 = pin 5                                          Rx
//
 Vss = pin 14  ==> GND
 Vdd = pin 1   ==> +Vcc
*/
/*
 Mappatura pins del PIC16F1829
// --- Pull-Up: tutti
 RA0 = pin 19   ICSP_DAT                         AN0        
 RA1 = pin 18   ICSP_CLK                         AN1
 RA2 = pin 15                                                AN2
 RA3 = pin 4    MCLR
 RA4 = pin 3            OSC2                AN4
 RA5 = pin 2            OSC1
//
 RB4 = pin 13                                                AN10
 RB5 = pin 12                                        Rx        AN11
 RB6 = pin 11
 RB7 = pin 10                                        Tx
//
 RC0 = pin 16                                                AN4
 RC1 = pin 15                                                AN5
 RC2 = pin 14                                                  AN6
 RC3 = pin 7                                                  AN7
 RC4 = pin 6                                          Tx
 RC5 = pin 5                                         Rx
 RC6 = pin 8                                                  AN8
 RC7 = pin 9                                                 AN9
//
 Vss = pin 20  ==> GND
 Vdd = pin 1   ==> +Vcc
*/