/*

               LIBRERIA PER DISPLAY GLCD NOKIA 3310
               
                      V3
                      
    !!!!!!!!!!!!!! Aggiornato per oscilloscope con PIC16 e GLCD Nokia 3310 !!!!!!!!!!!!!!!!!!!!!

*/
#define D_C    PORTA.F4       // Select Command register
#define _SCE   PORTA.F5       // Enable
//#define _RES   PORTC.F7       // Reset
#define SCK    PORTC.F4       //
#define SDI    PORTC.F5       //
//
 #include "Oscillo_Nokia_10x48.h"
 #include "Oscillo_Nokia_1_bmp.h"
//
  unsigned short interi, decimi, centesimi, millesimi;
  unsigned short buf_8;
  unsigned int buf_16;
//
void Dec_BCD_Short (unsigned short, unsigned short, unsigned short, unsigned short);
void Decimale_BCD (unsigned int, unsigned short, unsigned short, unsigned short);
void Delay_2us ();
void Delay_msec (unsigned int);
void initlcd(void);               // Initializes the LCD.
void writecom(char);            // Writes a command.
void writedata(char);            // Writes data to DDRAM to illuminate the pixels.
void clockdata(char);            // Clocks in data into the PCD8544 controller.
void clearram(void);            // Erase the DDRAM contents.
void cursorxy(char,char);         // Position cursor to x,y.
void nokia_erase_y(char);
void nokia_erase_x(char);
void nokia_plot(char,char);
void nokia_write_data_inv(char);
void putchar(char, char width);               // Write one character.
void putstr(const char *);         // Writes a string of characters.
void inicpu();
void Write_Bitmap();
void Draw_line_vert_KS0713(unsigned char, unsigned char, unsigned char, char);
void NOKIA_Dot (char x, char y);
//
 unsigned char const Byte_LOW [8] ={0b11111111,0b11111110,0b11111100,0b11111000,
                                    0b11110000,0b11100000,0b11000000,0b10000000};
 unsigned char const Byte_HIGH [8] ={0b00000001,0b00000011,0b00000111,0b00001111,
                                     0b00011111,0b00111111,0b01111111,0b11111111};
//
//
// *****************************************************************************
//
// *****************************************************************************
 const char table[490] = {                      // ASCII table for NOKIA LCD: 96 rows * 5 bytes= 480 bytes
                     0x00,0x00,0x00,0x00,0x00, // 20 space
                     0x00,0x00,0x5f,0x00,0x00, // 21 !
                     0x00,0x07,0x00,0x07,0x00, // 22 "
                     0x14,0x7f,0x14,0x7f,0x14, // 23 #
                     0x24,0x2a,0x7f,0x2a,0x12, // 24 $
                     0x23,0x13,0x08,0x64,0x62, // 25 %
                     0x60,0x60,0x7F,0x03,0x03, // TRIGGER: FRONTE IN SALITA     //* & */
                     0x03,0x03,0x7F,0x60,0x60, // TRIGGER: FRONTE IN DISCESA    //* ' */  0x27
                     0x00,0x1c,0x22,0x41,0x00, // 28 (
                     0x00,0x41,0x22,0x1c,0x00, // 29 )
                     0x14,0x08,0x3e,0x08,0x14, // 2a *
                     0x08,0x08,0x3e,0x08,0x08, // 2b +
                     0x00,0x50,0x30,0x00,0x00, // 2c ,
                     0x08,0x08,0x08,0x08,0x08, // 2d -
                     0x00,0x60,0x60,0x00,0x00, // 2e .
                     0x20,0x10,0x08,0x04,0x02, // 2f /
                     0x3e,0x51,0x49,0x45,0x3e, // 30 0
                     0x00,0x42,0x7f,0x40,0x00, // 31 1
                     0x42,0x61,0x51,0x49,0x46, // 32 2
                     0x21,0x41,0x45,0x4b,0x31, // 33 3
                     0x18,0x14,0x12,0x7f,0x10, // 34 4
                     0x27,0x45,0x45,0x45,0x39, // 35 5
                     0x3c,0x4a,0x49,0x49,0x30, // 36 6
                     0x01,0x71,0x09,0x05,0x03, // 37 7
                     0x36,0x49,0x49,0x49,0x36, // 38 8
                     0x06,0x49,0x49,0x29,0x1e, // 39 9
                     0x00,0x36,0x36,0x00,0x00, // 3a :
                     0x00,0x56,0x36,0x00,0x00, // 3b ;
                     0x08,0x14,0x22,0x41,0x00, // 3c <
                     0x14,0x14,0x14,0x14,0x14, // 3d =
                     0x00,0x41,0x22,0x14,0x08, // 3e >
                     0x02,0x01,0x51,0x09,0x06, // 3f ?
                     0x32,0x49,0x79,0x41,0x3e, // 40 @
                     0x7e,0x11,0x11,0x11,0x7e, // 41 A
                     0x7f,0x49,0x49,0x49,0x36, // 42 B
                     0x3e,0x41,0x41,0x41,0x22, // 43 C
                     0x7f,0x41,0x41,0x22,0x1c, // 44 D
                     0x7f,0x49,0x49,0x49,0x41, // 45 E
                     0x7f,0x09,0x09,0x09,0x01, // 46 F
                     0x3e,0x41,0x49,0x49,0x7a, // 47 G
                     0x7f,0x08,0x08,0x08,0x7f, // 48 H
                     0x00,0x41,0x7f,0x41,0x00, // 49 I
                     0x20,0x40,0x41,0x3f,0x01, // 4a J
                     0x7f,0x08,0x14,0x22,0x41, // 4b K
                     0x7f,0x40,0x40,0x40,0x40, // 4c L
                     0x7f,0x02,0x0c,0x02,0x7f, // 4d M
                     0x7f,0x04,0x08,0x10,0x7f, // 4e N
                     0x3e,0x41,0x41,0x41,0x3e, // 4f O
                     0x7f,0x09,0x09,0x09,0x06, // 50 P
                     0x3e,0x41,0x51,0x21,0x5e, // 51 Q
                     0x7f,0x09,0x19,0x29,0x46, // 52 R
                     0x46,0x49,0x49,0x49,0x31, // 53 S
                     0x01,0x01,0x7f,0x01,0x01, // 54 T
                     0x3f,0x40,0x40,0x40,0x3f, // 55 U
                     0x1f,0x20,0x40,0x20,0x1f, // 56 V
                     0x3f,0x40,0x38,0x40,0x3f, // 57 W
                     0x63,0x14,0x08,0x14,0x63, // 58 X
                     0x07,0x08,0x70,0x08,0x07, // 59 Y
                     0x61,0x51,0x49,0x45,0x43, // 5a Z
                     0x00,0x7f,0x41,0x41,0x00, // 5b [
                     0x02,0x04,0x08,0x10,0x20, // 5c Yen Currency Sign
                     0x00,0x41,0x41,0x7f,0x00, // 5d ]
                     0x04,0x02,0x01,0x02,0x04, // 5e ^
                     0x40,0x40,0x40,0x40,0x40, // 5f _
                     0x00,0x01,0x02,0x04,0x00, // 60 `
                     0x20,0x54,0x54,0x54,0x78, // 61 a
                     0x7f,0x48,0x44,0x44,0x38, // 62 b
                     0x38,0x44,0x44,0x44,0x20, // 63 c
                     0x38,0x44,0x44,0x48,0x7f, // 64 d
                     0x38,0x54,0x54,0x54,0x18, // 65 e
                     0x08,0x7e,0x09,0x01,0x02, // 66 f
                     0x0c,0x52,0x52,0x52,0x3e, // 67 g
                     0x7f,0x08,0x04,0x04,0x78, // 68 h
                     0x00,0x44,0x7d,0x40,0x00, // 69 i
                     0x20,0x40,0x44,0x3d,0x00, // 6a j
                     0x7f,0x10,0x28,0x44,0x00, // 6b k
                     0x00,0x41,0x7f,0x40,0x00, // 6c l
                     0x7c,0x04,0x18,0x04,0x78, // 6d m
                     0x7c,0x08,0x04,0x04,0x78, // 6e n
                     0x38,0x44,0x44,0x44,0x38, // 6f o
                     0x7c,0x14,0x14,0x14,0x08, // 70 p
                     0x08,0x14,0x14,0x18,0x7c, // 71 q
                     0x7c,0x08,0x04,0x04,0x08, // 72 r
                     0x48,0x54,0x54,0x54,0x20, // 73 s
                     0x04,0x3f,0x44,0x40,0x20, // 74 t
                     0x3c,0x40,0x40,0x20,0x7c, // 75 u
                     0x1c,0x20,0x40,0x20,0x1c, // 76 v
                     0x3c,0x40,0x30,0x40,0x3c, // 77 w
                     0x44,0x28,0x10,0x28,0x44, // 78 x
                     0x0c,0x50,0x50,0x50,0x3c, // 79 y
                     0x44,0x64,0x54,0x4c,0x44, // 7a z
                     0x00,0x08,0x36,0x41,0x00, // 7b <
                     0x00,0x00,0x7f,0x00,0x00, // 7c |
                     0x00,0x41,0x36,0x08,0x00, // 7d >
                     8, 73, 42, 28, 8,         // 7e Right Arrow ->
                     8, 28, 42, 73, 8,         // 7f Left Arrow   <-
                     4, 2, 127, 2, 4,          // 80 Freccia in ALTO
                     16, 32, 127, 32, 16       // 81 Freccia in BASSO
 } ;

// ***************************************************************************** Ritardo 2 us
//
// *****************************************************************************
 void Delay_2us () {
    asm nop
 }
// ***************************************************************************** INIT LCD
//
// *****************************************************************************
 void initlcd(void){
  // _RES = 1;      // Set _RES HIGH.
   // Delay_msec(2);
     _SCE = 0;      // Select Chip.
      Delay_msec(2);
   //    _RES = 0;      // Reset the LCD.
      //  Delay_msec(100);   // Wait 100ms.
      //   Delay_msec(2);
    //      _RES = 1;      // Awake LCD from RESET state.
       //    Delay_msec(2);
//
   writecom(0x21);      // Activate Chip and H=1.
   writecom(0xC2);      // Set LCD Voltage to about 7V.
   writecom(0x13);      // Adjust voltage bias.
   writecom(0x20);      // Horizontal addressing and H=0.
   writecom(0x09);      // Activate all segments.
   delay_ms(100);
   //clearram();      // Erase all pixel on the DDRAM.
   writecom(0x08);      // Blank the Display.
   delay_msec(100);
   writecom(0x0C);      // Display Normal.
   delay_msec(100);
   cursorxy(0,0);      // Cursor Home.
   clearram();
    _SCE = 1;            // Deselect Chip.
 }
// ***************************************************************************** SCRIVE COMANDO
//
// *****************************************************************************
 void writecom(char command_in){
   D_C = 0;            // Select Command register.
    Delay_2us();
     _SCE = 0;            // Select Chip.
      Delay_2us();
       clockdata(command_in);   // Clock in command bits.
        _SCE = 1;            // Deselect Chip.
         Delay_2us();
 }
// ***************************************************************************** SCRIVE DATA
//
// *****************************************************************************
 void writedata(char data_in){
   D_C = 1;            // Select Data register.
    Delay_2us();
     _SCE = 0;            // Select Chip.
      Delay_2us();
       clockdata(data_in);      // Clock in data bits.
       _SCE = 1;            // Deselect Chip.
        Delay_2us();
 }
// ***************************************************************************** CLOCK DATA
//
// *****************************************************************************
 void clockdata(char bits_in){
 // int bitcnt;
//
     for (buf_8=8; buf_8>0; buf_8--) {
        SCK = 0;
         Delay_2us();
// Set Clock Idle level LOW.
          if ((bits_in & 0x80) == 0x80) {                 // PCD8544 clocks in the MSb first
            SDI=1;
             Delay_2us();
          }
           else {
            SDI=0;
             Delay_2us();
           }
            SCK = 1;         // Data is clocked on the rising edge of SCK.
             Delay_2us();
// Data is clocked on the rising edge of SCK.
              bits_in = bits_in << 1;
// Logical shift data by 1 bit left.
     }
 }
// ***************************************************************************** CLEAR LCD
//
// *****************************************************************************
 void clearram(void){
  int buf_16;
//
    cursorxy(0,0);
      // Cursor Home.
      for (buf_16=504; buf_16>0; buf_16--) writedata(0x00);  // 6*84 = 504 DDRAM addresses.
 }
// ***************************************************************************** POSIZIONE CURSORE (X,Y)
//
// *****************************************************************************
 void cursorxy(char x, char y){
   writecom(0x40|(y&0x07));   // Y axis
   writecom(0x80|(x&0x7f));   // X axis
 }
// ***************************************************************************** POSIZIONE Colonna
//
// *****************************************************************************
 void Set_Colonna_x(char x){
   writecom(0x80|(x&0x7f));   // X axis
 }
// *****************************************************************************  POSIZIONE Pagina
//
// *****************************************************************************
 void Set_Page_y(char y){
   writecom(0x40|(y&0x07));   // Y axis
 }
// *****************************************************************************
//
// *****************************************************************************
 void nokia_erase_y(char ynokia) {
  char row;
///
     for(row=0;row<79;row++) {
       cursorxy(row,ynokia);
        putchar(' ', 0);
     }
 }
// *****************************************************************************
//
// *****************************************************************************
 void nokia_erase_x(char xnokia) {
  char buf_8;
//
    for (buf_8=0;buf_8!=6;buf_8++){
      cursorxy(xnokia,buf_8);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
      writedata(0x00);
    }
 }
// *****************************************************************************
//                         Disegna colonna da bitmap
// *****************************************************************************
// DISEGNA UNA COLONNA PER VOLTA DA BITMAP (Oscillo_Nokia_10x48)
 void nokia_colonna_Bitmap(char colonna) {
  unsigned char i, temp;
//
    temp = colonna;
      while (temp >= 10) {
         temp -= 10;
      }
// --- Select_Mark_Hor = 0 or 1: copy colonna reticolo + Marker

       for (i=0; i<=5; i++){
         reticolo_page [i] = Oscillo_Nokia_10x48 [temp + (i * 10)];
          if (Select_Mark_Hor != 2) {
            if (colonna.B2) {
              if (page_M_H_sup == i) reticolo_page [i] |= offset_M_H_sup;
               if (page_M_H_inf == i) reticolo_page [i] |= offset_M_H_inf;
            }
             if (Select_Mark_Hor == 0 && page_M_H_sup == i && colonna.B1) {
               reticolo_page [i] |= offset_M_H_sup;
             }
              if (Select_Mark_Hor == 1 && page_M_H_inf == i && colonna.B1) {
                reticolo_page [i] |= offset_M_H_inf;
              }
          }
       }
//
       for (i=0; i<=5; i++){
          cursorxy(colonna, i);
          // writedata (Oscillo_Nokia_10x48 [temp + (i * 10)]);
          writedata (reticolo_page [i]);
       }
 }
// ***************************************************************************** DISEGNA LINEA X
// Da x1 a x2
// pos = posizione y
// *****************************************************************************

 void Draw_line_oriz_3310(unsigned short x1, unsigned short x2, unsigned short pos) {
  char i;
//
     for (i=x1; i<=x2; i++) {
        NOKIA_Dot (i, pos);
     }
 }
// ***************************************************************************** SCRIVE CARATTERE
//
// *****************************************************************************
 void putchar(char character, char width){
  int tablept, char_column;
  char count;
//
     if ((character<0x20)||(character>0x81)) return; // Exit function if character is not found.
       tablept = ((5*character) - 160);

// Point to the columns of the character in the table.
// Draw the columns to print the character.
       for (count=5; count>0; count--) {
         if (width.F7) char_column = ~table[tablept];
           else char_column = table[tablept];
            writedata(char_column);
             tablept++;
       }
         if (width.F7) writedata(0xFF);    // 1 pixel spacing per character.
           else writedata(0x00);


 }
// ***************************************************************************** SCRIVE STRINGA
//
// *****************************************************************************
 void putstr(const char *s) {
   while(*s) {putchar(*s++, 0);}
// Points to one ASCII to be written one at a time.
 }
// *****************************************************************************
//          SCRIVE UNA STRINGA DI CARATTERI
//                                         Write_String_KS0713 ("JUMBO elettronica", 5, 28, 5);
//  page: da 0 a 5, se page,7 = 1: scrive in contrasto.
//
// *****************************************************************************
 void Write_String(char string[], unsigned char Page, unsigned char colonna) {
  unsigned short i = 0, temp_count, _Data;
  //int temp;
//
     cursorxy(colonna, (Page & 0x0F));      // Numero di pagina e colonna
//
      temp_count = 0;
//
     //  while (string [i] != 0) {
       while (string [i] != 0 && i < 4) {
           buf_16 = string [i];
            buf_16 -= 0x20;
             buf_16 *= 5;
//
              while (temp_count <= 4) {
                 if (Page.F7) _Data = ~table[buf_16];
                  else _Data = table[buf_16];
                   writedata(_Data);
                    temp_count ++; 
                     buf_16 ++;
              }
//
          if (Page.F7) writedata(0xFF);         // Spazio tra caratteri
           else writedata(0x00);
            i ++;
             temp_count = 0;
       }
 }
// *****************************************************************************
//             SCRIVE BITMAP SU MEMORIA RAM NOKIA 3310
// *****************************************************************************
 void Write_Bitmap(char bmp) {
 // unsigned int bitmap_byte=0;
//
    cursorxy(0, 0);
     buf_16 = 0;
//
    D_C = 1;            // Select Data register.
     Delay_2us();
      _SCE = 0;            // Select Chip.
       Delay_2us();
        do {
        //  if (bmp == 0) clockdata (Oscillo_Nokia_1_bmp [bitmap_byte]);
          // else if (bmp ==1) clockdata (mikro_bmp [bitmap_byte]);
          // else
             if (bmp == 2) clockdata (JUMBO70x40 [buf_16]);
            
        } while (++buf_16 <= 503);
           _SCE = 1;            // Deselect Chip.
 }
// ***************************************************************************** LINEA VERTICALE
//  DISEGNA UNA LINEA VERTICALE TRA I PUNTI Y1 E Y2 (0-47) ALLA COLONNA [0-83]
//----------------------------------------------------------------------
// Y1: Riga iniziale linea
// Y2: Riga finale linea
// colonna: Colonna dove disegnare la linea
// colore: 1 => scrivi 1; 0 => scrivi 0.
// colore = 128 (B7): Solo linea verticale
// *****************************************************************************
 void Draw_line_vert_3310(char Y1, char Y2, char colonna, char colore) {
  unsigned char temp_1, temp_2, page_1, page_2, _data;
  char temp, ret_sup, ret_inf;  // rettircolo superiore e reticolo inferiore
//
   if (colonna >=84) colonna = 83;
    if (Y1 >= 48) Y1 = 48;
     if (Y2 >= 48) Y2 = 48;
//
   if (Y1 > Y2) {temp_1 = Y2 ; Y2 = Y1; Y1 = temp_1;}   // Y1 sempre > di Y2
    page_1 = Y1 >> 3;
     temp_1 = page_1;
      page_2 = Y2 >> 3;
       temp_2 = page_2;
      Y1 &= 0x07;
       Y2 &= 0x07;
// --- Rileva reticolo da da sommare al tratto superiore e inferiore
    temp = colonna;
     while (temp >= 10) {
       temp -= 10;
     }
      ret_sup = Oscillo_Nokia_10x48 [temp + (page_1 * 10)];
       ret_inf = Oscillo_Nokia_10x48 [temp + (page_2 * 10)];

//  -------------------------------------- Solo quando la pagina 1 e la 2 sono uguali
    if (page_1 == page_2) {
      cursorxy(colonna, page_1);
      // if (colore == 1) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2] | ret_sup); // OR con il reticolo
       if (colore == 1) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2] | reticolo_page[page_1]); // OR con il reticolo
        else if (colore >= 129) writedata (Byte_LOW [Y1] & Byte_HIGH [Y2]); // Solo linea
         else writedata (0x00);
          return;
    }
//  -------------------------------------- Pagine intermedie (0xFF)
     page_1 += 1;
    if (colore) _data = 0xFF ;
     else _data = 0x00 ;
   while (page_1 < page_2) {
      cursorxy(colonna, page_1);
       writedata (_data);
        page_1 ++;
     }
//  --------------------------------------- Pagina Low
      cursorxy(colonna, temp_1);
       if (colore == 1) writedata (Byte_LOW [Y1] | ret_inf); // OR con il reticolo
     //  if (colore == 1) writedata (Byte_HIGH [Y2] | reticolo_page[temp_1]); // OR con il reticolo
        else if (colore >= 129) writedata (Byte_LOW [Y1]); // Solo linea                                               // Byte_LOW [X1] | Read_Data (0xFF, colonna)
         else writedata (0x00);
//  --------------------------------------- Pagina High
       cursorxy(colonna, temp_2);
      //  if (colore == 1) writedata (Byte_HIGH [Y2] | ret_sup); // OR con il reticolo
        if (colore == 1) writedata (Byte_HIGH [Y2] | reticolo_page[temp_2]); // OR con il reticolo
         else if (colore >= 129) writedata (Byte_HIGH [Y2]); // Solo linea
          else writedata (0x00);
}
// *****************************************************************************
//                       STAMPA IL BYTE NELLA POSIZIONE INDICATA
// --------------------------------------------------- Da decimale a BCD
// Value: numero tipo "short" da scomporre e visualizzare sul display
// page: Pagina (0-7)
// colonna: colonna (0-127)
// width: F7= 0: normale, F7= 1: reverse  (0x00/0x80)
//        F6= 0 | F5= 0: XXX              (0x00)
//        F6= 1 | F5= 1: 0,XXX            (0x60) (F7=1: 0xE0)
//        F6= 0 | F5= 1: X,XX             (0x20) (F7=1: 0xA0)
//        F6= 1 | F5= 0: XX,X             (0x40) (F7=1: 0xC0)
//
// *****************************************************************************
 void Dec_BCD_Short (unsigned int Value, unsigned short page, unsigned short colonna, unsigned short width) {
  unsigned short cnt;
 //unsigned short interi, decimi, centesimi;
//
     cursorxy(colonna, page);
//
// --> 3 cifre
          interi = Value / 100 ;                   // unit
           buf_8 = Value - (interi * 100) ;
            decimi = buf_8 / 10;                  // decimi
             centesimi = buf_8 - (decimi * 10) ;
//
       if (page >= 6) return;
// --- 0,XXX
        if (width.F6 && width.F5) {              // 0 iniziale (formato: 0,XXX)
          putchar(48, width);
           putchar(',', width);
            cnt = 2;
        }
// --- interi
         if (interi == 0 && width.F5==0) putchar(32, 0);  // se interi = 0, non visualizzarlo
          else putchar(interi+48, width);
           cnt ++;
// --- X,XX
           if (width.F6== 0 && width.F5) {   // formato: X,XX
             putchar(',', width);
              cnt ++;
           }
            putchar(decimi+48, width);
             cnt ++;
// --- XX,X
             if (width.F6 && width.F5 == 0) {   // formato: XX,X
               putchar(',', width);
                cnt ++;
             }
              putchar(centesimi+48, width);
               cnt ++;
//
              if (cnt < 4) putchar(' ', width);
 }
// *****************************************************************************
//                     STAMPA LA WORD NELLA POSIZIONE INDICATA
// *****************************************************************************
 void Decimale_BCD (unsigned int Value, unsigned short page, unsigned short colonna, unsigned short Width) {
 // unsigned int buffer;
 // unsigned short interi, decimi, centesimi, millesimi;
//
        if (Value >= 9999) Value = 9999;
         cursorxy(colonna, page);
// --> 4 cifre
          interi = Value / 1000 ;                   // unit
           buf_16 = Value - (interi * 1000) ;
            decimi = buf_16 / 100;                  // decimi
             buf_16 = buf_16 - (decimi * 100) ;
              centesimi = buf_16 / 10;
               millesimi = buf_16 - (centesimi * 10) ;
//
      if (page >= 5) return;
       if (Width.F6) { goto Decimale_BCD_loop; }
        else {
         if (interi == 0 && Width.F5 == 1) putchar(32, width);
          else putchar(interi+48, width);
           colonna += 6;
           if (Width.F5 == 0) {
             putchar(',', width);
              colonna += 3;
           }
        }
 Decimale_BCD_loop:
       putchar(decimi+48, width);
        colonna += 6;
         putchar(centesimi+48, width);
          colonna += 6;
          if (Width.F6) {
            putchar(',', width);
             colonna += 3;
              putchar(millesimi+48, width);
          }
            else putchar(millesimi+48, width);
            
//          putchar(char character)

// --> 3 cifre
     /*   if (Value >= 999) Value = 999;
          interi = Value/100 ;
           buffer = Value - (interi * 100) ;
            decimi = buffer / 10;
             centesimi = buffer - (decimi * 10) ;
//
       if (page >= 9) return;
       Write_Font_KS0713(interi+48, page, colonna, Width);
        Write_Font_KS0713(',', page, colonna + 6, Width);
               Write_Font_KS0713(decimi+48, page, colonna + 9, Width);
          Write_Font_KS0713(centesimi+48, page, colonna + 15, Width);   */
 }
// *****************************************************************************
//
// *****************************************************************************
void NOKIA_Goto_pixel(char x, char y) {
        writecom(0x40|(y & 0x07));
        writecom(0x80|(x & 0x7F));
 }
// *****************************************************************************
//
// *****************************************************************************
 void NOKIA_Dot (char x, char y){
  char offset, datar;

        if (x > 84) return;
        if (y > 48) return;

        offset = y - ((y / 8) * 8);
        datar = (0x01 << offset);
        NOKIA_goto_pixel(x, (y/8));
        writedata(datar);
 }

/*






















*/
// END